import javax.swing.JOptionPane;
import java.util.Locale;

public class kanatliisidegistirici3DT
{ // yüksek kanatlı boru ısı değiştirici
  liquid_CS soguk_sivi; // soğuk sıvı (boru içi)
  Gmix sicak_sivi;      // sıcak sıvı (boru dışı)
  steam st1;            // su buharı
  String g[];   // karışımdaki gaz isimleri
  double gn[];  // karışımdaki gaz mol sayıları (karışım %leri)
  double s;     //kanatlar arası mesafe
  int nkanat;
  double delta; //kanat kalınlığı
  double hf;    //kanat yüksekliği
  int n_sira;   //sıra sayısı (dikey)
  int n_boru;   //bir sıradaki boru sayısı (yatay)
  double eps;   //yüzey pürüzlülüğü
  double di;    //boru iç çapı
  double dout;  //boru dış çapı
  double D;     //kanat çapı

  double fi;    
  double st;    // borular arası dikey mesafe
  double sl;    // borular arası yatay mesafe
  double dP;    // basınç düşümü
  double Uortalama;
  double Cportalama;
  double L; //kanal boyu
  double W; //kanal genişliği
  double H; //kanal yüksekliği
  double eod;      // eps/di
  double Tsoguk[];
  double Tsicak[];
  double x[];      // ısı değiştirici boy koordinatı
  double Q;        // ısı transferi
  double Qlmtd;    // ısı transferi LMTD metodu
  double LMTD;
  double KL;       // yerel basınç düşüş katsayısı
  double Aboru;    // boru yüzey alanı
  double A;
  double msoguk;   // soğuk akışkan debisi
  double Vsicak;   //sıcak gaz hızı m/s
  double msicak;    // sicak akışkan debisi
  double Ric,Rdis;  // Boru yüzeyi ısıl direnç katsayıları
  double kboru;     // boru ve kanat ısı iletim katsayısı
  double dL;        // sonlu farklar boru blünüm sayısı
  int n_finite;     // sonlu farklar step sayısı
  double rosicak;   // baca giriş sıcaklığı
  double tic,tdis;
 public kanatliisidegistirici3DT(String isoguk_sivi,
 String isicak_sivi,String gi[],double gni[],
 double si,double deltai,double Di,int n_sirai,int n_borui, double epsi,
 double dii, double douti, double Li, double Wi, double Hi,
 double msoguki,double Kboru, double Rici, double Rdisi,double KLi,
 double dLi)
 {soguk_sivi=new liquid_CS(isoguk_sivi);
  sicak_sivi=new Gmix(isicak_sivi,gi,gni);
  st1=new steam();
  double nsteam=0;
  for(int i=0;i<gi.length;i++)
  {if(gi[i].equals("h2o")) nsteam=gni[i];}
  s=si;
  delta=deltai;
  D=Di;
  n_sira=n_sirai;
  n_boru=n_borui;
  eps=epsi;
  di=dii;
  dout=douti;
  fi=(D/dout-1)*(1+0.35*Math.log(D/dout));
  hf=(D-dout)/2.0;
  L=Li;
  W=Wi;
  H=Hi;
  nkanat=(int)(L/(s+delta));
  Ric=Rici;
  Rdis=Rdisi;
  dL=dLi;
  KL=KLi;
  n_finite=(int)(L*n_boru/dL+0.0001)+1;
  Tsoguk=new double[n_finite*n_sira+1]; 
  // borunun seri olarak bağlandığını kabul etti
  Tsicak=new double[n_finite*n_sira+1];  //her sırada sıcaklık sabit
  x=new double[n_finite*n_sira]; //sıcaklık koordinatı
  Q=0;
  //Vsicak=Vsicaki;
  kboru=55; //Aliminium W/mK
  msoguk=msoguki;
  //msicak eksoz sıcaklığından hesaplanacak
  }  
  // eps     : pipe equivalent roughness m
  //          -------------------------------------------
  //          value of equivalent roughness for some pipes:
  //          Pipe             equivalent rougness m
  //          -------------    ---------------------
  //          Riveted steel    0.9e-3 - 9e-3
  //          Concrete         0.3e-3 - 3e-3
  //          Wood stave       0.18e-3 - 0.9 e-3
  //          Cast iron        0.26e-3
  //          Galvanised iron  0.15e-3
  //          Commercial steel 0.045e-3
  //          wrought iron     0.045e-3
  //          drawn tubing     0.0015e-3
  //          Plastic,glass    0.0 (smooth)
  //          -------------------------------------------
// boru içi 
 public double f(double Re)
 {
 //Haaland equation
 //double f1=-1.8*Math.log10(Math.pow((eod/3.7),1.11)+6.9/ Re);
 //f1=1.0/(f1*f1);
 
 //Swamee-Jain equation
 //double A=Math.log10(eod/3.7+5.74/Math.pow(Re,0.9));
 //double f1=0.25/(A*A);

 //Serghides equation
 //double A1=-2.0*Math.log10(eod/3.7+12.0/Re);
 //double B1=-2.0*Math.log10(eod/3.7+2.51*A1/Re);
 //double C1=-2.0*Math.log10(eod/3.7+2.51*B1/Re);
 //double f1=A1-((B1-A1)*(B1-A1))/(C1-2.0*B1+A1);
 //f1=1.0/(f1*f1);
 //System.out.println("Sergides equation f1="+f1);
 //Goudar equation 
 double a=2/Math.log(10);
 double b=eod/3.7;
 double d=Math.log(10.0)/5.02*Re;
 double s=b*d+Math.log(d);
 double q=Math.pow(s,(s/(s+1)));
 double g=b*d+Math.log(d/q);
 double z=Math.log(q/g);
 double dLA=(g/(g+1))*z;
 double dCFA=dLA*(1+z/2.0/((g+1)*(g+1)+(z/3)*(2.0*g-1)));
 double f1=a*(Math.log(d/q)+dCFA);
 f1=1.0/(f1*f1);
 //System.out.println("Goudar equation f1="+f1);
 return f1;
 }
//boru içi 
public double fx(double X,double Re)
{
// colebrook equation to solve
// friction factor for turbulent flow 2000 < Re
double xx=2.0*Math.log10(eod/3.7+2.51/Re*X)+X;
return xx;
}
//boru içi 
public double dfx(double X,double Re)
{
//derivative of colebrook equation
double xx;
xx = 1+2.0/(eod/3.7+2.51/Re*X)/Math.log(10.0)*2.51/Re;
return  xx;
}
//boru içi 
public  double fcol(double Re)
{
// solution of the colebrook equation
// by using newton method
double fi=f(Re);
double xx=1.0/ Math.pow(fi,0.5);
int nmax=50;
double tolerance=1.0e-10;
for(int i=0;i<nmax;i++)
{
double fx1=fx(xx,Re);
xx-=fx1/dfx(xx,Re);
if(Math.abs(fx1)<tolerance) 
{double ff=1.0/(xx*xx);
return ff;}
}
double ff=1.0/(xx*xx);
//System.out.println("fcol="+ff);
return ff;
}
//boru içi 
public double  velocity(double t)
{
// velocity of the pipe m/x
double x=0.0;
double mboru=msoguk/n_boru;
double ro=soguk_sivi.rd.rol(t+273.15);
double AA=Math.PI*di*di/4.0;
return mboru/ro/AA;
}

//boru içi 
public double  Re(double t)
{
// reynold's number boru içi
double ro=soguk_sivi.rd.rol(t+273.15);
double vis=soguk_sivi.rd.viscosity_l(t+273.15);
double vv=velocity(t);
double res=(di*vv*ro/vis);
return res;
}
//boru içi 
public double  hc(double t)
{
//convective heat transfer coefficient
double Rey=Re(t);
double Nu=0;
double Prt=1.0;
if(Rey<=2300)
{  //Laminar region
	Nu=3.66; 
}
else if(Rey>2300 && Rey<=3100)
{  //Referans : Heat transfer in all pipe flow regimes:laminar,transitional/intermittent, and turbulent
   // J.P. Abraham, E.M. Sparrow, J.C.K. Tong, International Journal of Heat and Mass Transfer 52(2009) 557-563
	double Re1=(Rey/1000.0);
	Nu=2.2407*Re1*Re1*Re1*Re1-29.499*Re1*Re1*Re1+142.32*Re1*Re1-292.51*Re1+219.88;}
else
  {
  double fr  = f(Rey);
  Prt = soguk_sivi.rd.Pr(t+273.15);
  // Turbulent region Gnielinski equation
  // Referance: 
  // V. Gnielinski, New equations for heat and mass transfer in turbulent pipe and
  //channel flow, Int. Chem. Eng. 16 (1976) 359–367.
  // Valid for 2000 < Re <5e5, 0.5 < Pr < 2000
  Nu=fr/8.0*(Rey-1000.0)*Prt/
  (1+12.7* Math.sqrt(fr/8.0)*( Math.pow(Prt,(2.0/3.0))-1.0));
  }
  double kt  =  soguk_sivi.rd.k_l(t+273.15);
  double ss=Nu*kt/di;
  //System.out.println("Re="+Rey+"Nu="+Nu+"h="+ss+"Prt="+Prt+"kt="+kt+"di="+di);
  return ss;
}

// boru dışı ısı transferi
public double mout(double ti,double td)
{
double As=L*W-n_boru*L*dout-2.0*n_boru*nkanat*hf*delta;  //m^2 giriş alanı
double A=L*W;
//======= Grashoff sayısı boru dışı ==========	
//x : % karışım miktarı
//ti sıvı sıcaklığı
//td dış hava sıcaklığı	
//boru geçiş alanı
double beta=1.0/(td+273.15);
double g=9.806; //yerçekimi sabiti
double de=dout+hf;
double te=(ti+td)/2.0;
double ro=sicak_sivi.M/sicak_sivi.v((te+273.15),1.01325);
double vis=sicak_sivi.vis(te+273.15)/ro;
double Pr=sicak_sivi.Prandtl(te+273.15);
double k=sicak_sivi.k(te+273.15);
double dt=(ti-td);
double grashoff=g*de*de*de*beta*dt/vis/vis;
double Re=Math.sqrt(grashoff);
double u=Re*vis/de;
double m=u*As*ro;
return m;
}

public double U(double ti,double td)
{
//======= Grashoff sayısı boru dışı ==========	
//x : % karışım miktarı
//ti sıvı sıcaklığı
//td dış hava sıcaklığı	
//boru geçiş alanı
double beta=1.0/(td+273.15);
double g=9.806; //yerçekimi sabiti
double de=dout+hf;
double te=(ti+td)/2.0;
double ro=sicak_sivi.M/sicak_sivi.v((te+273.15),1.01325);
double vis=sicak_sivi.vis(te+273.15)/ro;
double Pr=sicak_sivi.Prandtl(te+273.15);
double k=sicak_sivi.k(te+273.15);
double dt=(ti-td);
double grashoff=g*de*de*de*beta*dt/vis/vis;
double Re=Math.sqrt(grashoff);
double u=Re*vis/de;
return u;
}

public double Reout(double ti,double td)
{ return Math.sqrt(Grashoff(ti,td));}

public double Grashoff(double ti,double td)
{
//======= Grashoff sayısı boru dışı ==========	
//x : % karışım miktarı
//ti sıvı sıcaklığı
//td dış hava sıcaklığı	
//boru geçiş alanı
double beta=1.0/(td+273.15);
double g=9.806; //yerçekimi sabiti
double de=dout+hf;
double te=(ti+td)/2.0;
double ro=sicak_sivi.M/sicak_sivi.v((te+273.15),1.01325);
double vis=sicak_sivi.vis(te+273.15)/ro;
double Pr=sicak_sivi.Prandtl(te+273.15);
double k=sicak_sivi.k(te+273.15);
double dt=(ti-td);
double grashoff=g*de*de*de*beta*dt/vis/vis;
//System.out.println("ti="+ti+"td="+td+"dt="+dt+"beta="+beta+"g="+g+"de="+de+"te="+te+"ro="+ro+"vis="+vis+"Pr="+Pr+"k="+k+"rayleig="+rayleigh);
return grashoff;
}
public double Raout(double ti,double td)
{
//======= Rayleigh sayısı boru dışı ==========	
double te=(ti+td)/2.0;
double Pr=sicak_sivi.Prandtl(te+273.15);
return Pr*Grashoff(ti,td);
}

public double hout(double ti,double td)
{
// t  sıvı sıcaklığı	
//===== Boru dışı taşınım ısı transferi katsayısı W/M^2 K ===========
//	    kanatlı boru dizini
double Ra=Raout(ti,td);
double te=(ti+td)/2.0;
double vis=sicak_sivi.vis(te+273.15);
double k=sicak_sivi.k(te+273.15);
double Pr=sicak_sivi.Prandtl(te+273.15);
double de=dout+hf;
double n=nkanat/L;
double bd=hf/dout;
double Nu=0.24*Math.pow((Ra*bd),(1.0/3.0));
double ho=k/de*Nu;
return ho;   
}

public double X(double ti,double td)
{double hm=hout(ti,td);
 return fi*dout/2.0*Math.sqrt(2.0*hm/(kboru*delta));
}
public double eta(double ti,double td)
{ //kanat verimi
  double x=X(ti,td);
  return Math.tanh(x)/x;
}

public double houtv(double ti,double td)
{ double eta=eta(ti,td);
  double Af1=2.0*Math.PI/4.0*(D*D-dout*dout)*nkanat;
  double Af2=(D-dout)*Math.PI*D*nkanat;
  //System.out.println("Af1="+Af1+"Af2="+Af2);
  double A=Math.PI*dout*(L-nkanat*delta)+Af1;
  return hout(ti,td)*(1-(1-eta)*Af1/A);
}

public double U0(double tic1,double tdis1)
{
	tic=tic1;
	tdis=tdis1;
double hi=hc(tic);    // boru içi ısı transferi
double ho=houtv(tic,tdis); // boru dışı ısı transferi
double Ai=Math.PI*di*L;
//double Af=2.0*Math.PI/4.0*(D*D-dout*dout)*nkanat;
//double Af1=2.0*Math.PI/4.0*(D*D-dout*dout)*nkanat;
//double Af2=(D-dout)*Math.PI*D*nkanat;

	double msic=msicak/n_boru;
	double Af=2.0*Math.PI/4.0*(D*D-dout*dout)*nkanat;
    double A=Math.PI*dout*(L-nkanat*delta)+Af;
    Aboru=A*n_boru*n_sira;

//double A=Math.PI*dout*(L-nkanat*delta)+Af1;
//Aboru=A*n_boru*n_sira;
double Uboru=1.0/(1.0/ho+A/Ai*(1.0/hi+(dout-di)/(2.0*kboru)));

return Uboru;
}

public void hesapla(double tic1, double tdis1)
{   Q=0;
    tic=tic1;
    tdis=tdis1;
	double dq=0;
	double roavg=0;
	double Vavg=0;
	double ms=msoguk/n_boru; //bir borudaki kütlesel debi
	double rosicak=sicak_sivi.M/sicak_sivi.v((tic+273.15),1.01325);
	msicak=rosicak*Vsicak*L*W;  //sabit 
	//double msic=msicak/n_boru;
	//double Af=2.0*Math.PI/4.0*(D*D-dout*dout)*nkanat;
	//double Af1=2.0*Math.PI/4.0*(D*D-dout*dout)*nkanat;
    //double Af2=(D-dout)*Math.PI*D*nkanat;
    //double A=Math.PI*dout*(L-nkanat*delta)+Af1;
    //Aboru=A*n_boru*n_sira;
    double msic=msicak/n_boru;
	double Af=2.0*Math.PI/4.0*(D*D-dout*dout)*nkanat;
    double A=Math.PI*dout*(L-nkanat*delta)+Af;
    Aboru=A*n_boru*n_sira;
	dP=0;
    double xx=0;
    double dtic=0;
    double dtdis=0;
    double Cp=0;
    Uortalama=0;
    Vavg=0;
    double uu=0;
    double dA=A/n_finite;
	for(int k=0;k<n_sira;k++)
	{ double dq1=0; 
	 //xx=0;
	 Cp=sicak_sivi.Cp(tdis+273.15)/sicak_sivi.M;
	 Cportalama+=Cp; 
	for(int i=0;i<n_finite;i++)
	{   double Rey=Re(tic);
	    double f=fcol(Rey);
	    Vavg+=velocity(tic);
		uu=U0(tic,tdis);
		Uortalama+=uu;
		dq=uu*dA*(tic-tdis);
		dq1+=dq;
		dtic=dq/(ms*soguk_sivi.rd.Cpl(tic+273.15)*1.0e3);		
	    Tsoguk[k*n_finite+i]=tic;
	    Tsicak[k*n_finite+i]=tdis;
	    x[k*n_finite+i]=xx;
	    tic-=dtic;

        xx+=dL;        
	}
	msic=mout(tic,tdis);
	dtdis=dq1/(msic*Cp*1.0e3);
	tdis+=dtdis;
    System.out.println("Cp="+Cp+"dq1="+dq1+"xx="+xx+"tic="+tic+"tdis="+tdis);
	Q+=dq1;    
	}
	Q*=n_boru;	
    roavg/=n_finite;
    Vavg/=n_finite;
    Uortalama/=(n_finite*n_sira); 
    Cportalama/=n_sira;   
    double dT1=Tsoguk[0]-Tsicak[0];
    double dT2=Tsoguk[n_finite*n_sira-1]-Tsicak[n_finite*n_sira-1];
    LMTD=(dT1-dT2)/Math.log(dT1/dT2);
    Qlmtd=Uortalama*Aboru*LMTD;
    dP+=KL*roavg*Vavg*Vavg/2.0;
}

public double hesapla_ters1(double tic, double tdisa)
{
     Q=0;
	double dq=0;
	double roavg=0;
	double Vavg=0;
	double ms=msoguk/n_boru; //bir borudaki kütlesel debi
	double rosicak=sicak_sivi.M/sicak_sivi.v((tic+273.15),1.01325);
	msicak=rosicak*Vsicak*L*W;  //sabit 
	//double msic=msicak/n_boru;
	//double Af=2.0*Math.PI/4.0*(D*D-dout*dout)*nkanat;
	//double Af1=2.0*Math.PI/4.0*(D*D-dout*dout)*nkanat;
    //double Af2=(D-dout)*Math.PI*D*nkanat;
    //double A=Math.PI*dout*(L-nkanat*delta)+Af1;
    //Aboru=A;
    double msic=msicak/n_boru;
	double Af=2.0*Math.PI/4.0*(D*D-dout*dout)*nkanat;
    double A=Math.PI*dout*(L-nkanat*delta)+Af;
    Aboru=A*n_boru*n_sira;
    //System.out.println("A="+A+"Aboru="+Aboru+"Af="+Af+"D="+D+"dout="+dout+"L="+L+"nkanat="+nkanat+"delta="+delta);
	dP=0;
    double xx=0;
    double dtic=0;
    double dtdis=0;
    double Cp=0;
    Uortalama=0;
    Vavg=0;
    double uu=0;
    double dA=A/n_finite;
    double dq1=0;
	for(int k=0;k<n_sira;k++)
	{ dq1=0; 
	 Cp=sicak_sivi.Cp(tdisa+273.15)/sicak_sivi.M;
	 Cportalama+=Cp;
	 //xx=0; 
	for(int i=0;i<n_finite;i++)
	{   double Rey=Re(tic);
	    double f=fcol(Rey);
	    Vavg+=velocity(tic);
		uu=U0(tic,tdisa);
		Uortalama+=uu;
		dq=uu*dA*(tic-tdisa);
		dq1+=dq;
		dtic=dq/(ms*soguk_sivi.rd.Cpl(tic+273.15)*1.0e3);
		
	    Tsoguk[k*n_finite+i]=tic;
	    Tsicak[k*n_finite+i]=tdisa;
	    x[k*n_finite+i]=xx;
	    tic+=dtic;
	    //System.out.println("xx="+xx+"tic="+tic+"tdis="+tdisa);
        xx+=dL;        
	}
	msic=mout(tic,tdisa);
	dtdis=dq1/(msic*Cp*1.0e3);
	tdisa+=dtdis;
	Q+=dq1;    
	}
    Q*=n_boru;		
    roavg/=n_finite;
    Vavg/=n_finite;
    Uortalama/=(n_finite*n_sira); 
    Cportalama/=n_sira;   
    double dT1=Tsoguk[0]-Tsicak[0];
    double dT2=Tsoguk[n_finite*n_sira-1]-Tsicak[n_finite*n_sira-1];
    LMTD=(dT1-dT2)/Math.log(dT1/dT2);
    Qlmtd=Uortalama*Aboru*LMTD;
    dP+=KL*roavg*Vavg*Vavg/2.0;
    return  Tsoguk[n_finite*n_sira-1];
}
public void plot()
{
 Plot pp=new Plot(x,Tsoguk);
 pp.addData(x,Tsicak);
 Locale us=new Locale("US");          
 String s1="Q = %4.1f kW A = %4.1f m^2 dP = %4.1f kPA U = %4.0f W/m^2K";
 String s4=String.format(us,s1,Q*1e-3,Aboru,dP*1e-3,Uortalama);
 pp.setPlabel(s4);
 pp.setXlabel("x, m");
 pp.setYlabel("T sıcaklık , derece C");
 pp.plot();
}

public String toString()
{String s="Isı değiştirici \n";
s+="boru içi akışkan = "+soguk_sivi.rd.liquidName+"\n";
s+="boru dışı akışkan = "+sicak_sivi.gasName+"\n";
s+=sicak_sivi.toString(sicak_sivi.gasName)+"\n";
s+="m_boru içi = "+msoguk+"\n kg/s";
s+="m_boru dışı = "+msicak+"\n kg/s";
s+="boru içi yüzey pürüzlülüğü : "+eps+"\n";
s+="boru içi çapı : "+di+"\n";
s+="boru dışı çapı : "+dout+"\n";
s+="basınç düşümü : "+dP+"\n";
s+="ortalama ısı transfer katsayısı : "+Uortalama+"\n";
s+="ortalama eksoz gazı özgül ısı kapasitesi = "+Cportalama+"kJ/kg K";
s+="Isı transferi : "+Q+"\n";
s+="Isı değiştirici alanı : "+Aboru+"\n";
s+="Isı değiştirici tek boru alanı : "+A+"\n";
s+="Soğuk akışkan giriş-çıkış sıcaklıkları : "+"\n";
s+=Tsoguk[0]+"   "+Tsoguk[n_sira*n_finite-1]+"\n";
s+="Sıcak akışkan giriş-çıkış sıcaklıkları : "+"\n";
s+=Tsicak[0]+"   "+Tsicak[n_sira*n_finite-1]+"\n";
s+="LMTD ="+LMTD+"derece K\n";
s+="Q_LMTD ="+Qlmtd+"W\n";
return s;
}
 



public void hesapla_ters(double tic, double tdis)
{
//ters akışlı sistem
//tic  : soğuk sıvı giriş sıcaklığı	
//tdis : sıcak sıvı giriş sıcaklığı
int nn=10;
double dT=(tic-tdis)/nn;
double Tgir[]=new double[nn];
double Tcik[]=new double[nn];
for(int i=0;i<nn;i++)
{ Tgir[i]=tic-dT*i;
  Tcik[i]=hesapla_ters1(Tgir[i],tdis);
  //System.out.println("i="+i+" "+Tcik[i]+" "+Tgir[i]);
}
double e[]=EKK(Tcik,Tgir,5);
double tgir1=funcEKK(e,tic);
double tdis2=hesapla_ters1(tgir1,tdis);
    double dT1=Tsoguk[0]-Tsicak[0];
    double dT2=Tsoguk[n_boru*n_finite-1]-Tsicak[n_boru*n_finite-1];
    LMTD=(dT1-dT2)/Math.log(dT1/dT2);
    Qlmtd=Uortalama*Aboru*LMTD;
}


//en kucuk kareler metodu	
  public static double[] pivotlugauss(double a[][],double b[])
  { //kısmi pivotlu gauss eleme yöntemi
  int n=b.length;	  
  double x[]=new double[n];
  double carpan=0;
  double toplam=0;
  double buyuk;
  double dummy=0;
  //gauss eleme
  int i,j,k,p,ii,jj;
  for(k=0;k<(n-1);k++)
  { //pivotlama
	p=k;
	buyuk=Math.abs(a[k][k]);
	for(ii=k+1;ii<n;ii++)
	{  dummy=Math.abs(a[ii][k]);
	   if(dummy > buyuk) {buyuk=dummy;p=ii;}
	}
	if(p!=k)
	{ for(jj=k;jj<n;jj++)
	  { dummy=a[p][jj];
	    a[p][jj]=a[k][jj];
	    a[k][jj]=dummy;
	  }
	  dummy=b[p];
	  b[p]=b[k];
	  b[k]=dummy;
	}
	//gauss elemeyi çözme  
    for(i=k+1;i<n;i++)
    {  carpan=a[i][k]/a[k][k];
       a[i][k]=0;
       for(j=k+1;j<n;j++)
       {   a[i][j]-=carpan*a[k][j]; }
           b[i]   =b[i]   -carpan*b[k];
	}
  }
  //geriye doğru yerine koyma
  x[n-1]=b[n-1]/a[n-1][n-1];
  for(i=n-2;i>=0;i--)
  {
    toplam=0;
    for(j=i+1;j<n;j++)
    {  toplam+=a[i][j]*x[j];}
    x[i]=(b[i]-toplam)/a[i][i];
  }
  return x;
}


  
public static double[] EKK(double xi[],double yi[],int n)
{
int l=xi.length;
int i,j,k;
int np1=n+1;
double A[][];
A=new double[np1][np1];
double B[];
B=new double[np1];
double X[];
X=new double[np1];
for(i=0;i<n+1;i++)
  {  for(j=0;j<n+1;j++)
     {if(i==0 && j==0) A[i][j]=l;
     else  for(k=0;k<l;k++) A[i][j] += Math.pow(xi[k],(i+j));
     }
     for(k=0;k<l;k++) { if(i==0)  B[i]+= yi[k];
                       else      B[i] += Math.pow(xi[k],i)*yi[k];}
  }
//System.out.println(Matrix.toString(A));
//System.out.println(Matrix.toStringT(B));  
X=pivotlugauss(A,B);
//X=B/A;
double max=0;
for(i=0;i<n+1;i++)
 if(Math.abs(X[i]) > max) max = Math.abs(X[i]);
for(i=0;i<n+1;i++)
 if((Math.abs(X[i]/max) > 0) && (Math.abs(X[i]/max) < 1.0e-100)) X[i]=0;
return X;
}

public static double funcEKK(double e[],double x)
{
// this function calculates the value of
// least square curve fitting function
int n=e.length;
double ff;
if(n!=0.0)
  { ff=e[n-1];
  for(int i=n-2;i>=0;i--)
   { ff=ff*x+e[i]; }
  }
else
  ff=0;
return ff;
}

public static double hata(double x[],double y[],double e[])
{
//calculates absolute square root error of a least square approach
double n=x.length;
 int k;
 double total=0;
 for(k=0;k<n;k++)
 {
 total+=(y[k]-funcEKK(e,x[k]))*(y[k]-funcEKK(e,x[k]));
 }
total=Math.sqrt(total);
return total;
}

public static double[][]  funcEKK(double xi[],double yi[],int polinomkatsayisi,int aradegersayisi)
{
//aradegersayisi:  x--o--o--x--o--o--x zincirinde x deneysel noktalar ise
// ara değer sayısı 2 dir
   int n=xi.length;
   int nn=(n-1)*(aradegersayisi+1)+1;
   double z[][]=new double[2][nn];
   double E[]=EKK(xi,yi,polinomkatsayisi);	
   System.out.println("katsayılar :\n"+Matrix.toStringT(E));
   double dx=0;
   int k=0;
   int i;
   for(i=0;i<(n-1);i++)
       {z[0][k]=xi[i];z[1][k]=funcEKK(E,z[0][k]);k++;
       for(int j=0;j<aradegersayisi;j++) 
       {dx=(xi[i+1]-xi[i])/((double)aradegersayisi+1.0);
       z[0][k]=z[0][k-1]+dx;z[1][k]=funcEKK(E,z[0][k]);k++;}
       }
       z[0][k]=xi[i];z[1][k]=funcEKK(E,z[0][k]);
   return z;
 } 
}